#ifndef __FEATURE_H
#define __FEATURE_H

#define MAX_NAME_LEN	24
#define MAX_DESC_LEN	30

typedef struct {
    void * data;				/* function of data */
    int use;					/* use it or not */
    char name[MAX_NAME_LEN];			/* name (short) */
    char desc[MAX_DESC_LEN];			/* description or long name */
} feature_entry;

typedef struct {
    char name[MAX_NAME_LEN];
    feature_entry * entries;
    int nr_entries;
    int current;
    int (* callback)(int);
} feature;

#define	CHANGE_RANDOM	-1
#define CHANGE_NEXT	-2
#define CHANGE_PREV	-3

int add_feature(feature * features, const feature_entry * entry);

feature_entry * feature_change(int to, feature * features);
feature_entry * feature_change2(char * to, feature * features);
int feature_defined(const char * name, const feature * features);

int init_startup();
int exit_startup();


#endif
