#include "cthugha.h"
#include "interface.h"
#include "keys.h"
#include "sound.h"
#include "cd_player.h"
#include "options.h"
#include "display.h"
#include "action.h"				/* display_sound() */
#include "translate.h"
#include "information.h"

#include <string.h>
#include <stdlib.h>


int sel_line = 0;
feature * sel_what = NULL;
char * sel_title = NULL;
int (* sel_callback)(int);

int do_selection();
int do_credits();
int main_key_switch(int);

interface_mode_t interface_mode = IM_main;

int interface() {
    int key;

    switch(interface_mode) {
    case IM_main:
	while( (key = getkey()) != CK_NONE) 
	    main_key_switch(key);
	break;
    case IM_selection:
	do_selection();
	break;
    case IM_credits:
	do_credits();
	break;
    case IM_options:
	if(options_dialog() )
	    interface_mode = IM_main;
	break;
    case IM_panel:
	switch( cd_player() ) {
	case 'c': case 'C':
	case CK_ESC: case 'q': case 'Q':
	    display_print_clear();
	    interface_mode = IM_main;
	}
    default:
	;
    }

    return 0;
}

/*****************************************************************************
 * Credits
 *****************************************************************************/

int do_credits() {
    
    static int i = 0;
    static int lasttime = 0;

    if(lasttime == 0) {
	display_print_clear();
	for(i=0; i < 50; i++)		/* start at bottom to print */
	    display_print(" ", -2, 'l', 0);

	for(i=0; i < 4; i++)
	    display_print(info_credits[i], -2, 'c', 0); 

	lasttime = gettime();
    }
	
    if( (gettime() - lasttime) > 50) {
	display_print(info_credits[i], -2, 'c', 0); 

	i = (i+1) % info_nr_credits;
	lasttime = gettime();
    }


    if( getkey() != CK_NONE)
	cthugha_close = 1;

    return 0;
}


/*****************************************************************************
 * main interface
 *****************************************************************************/

int main_key_switch(int key) {
    char str[256];

    switch( key ) {
    case CK_NONE:
	return 0;
    case CK_ESC: case 'q': case 'Q':				/* Exit */
	clear_status();
	if ( display_text_on_screen)
	    display_print_clear();
	else {
	    interface_mode = IM_credits;
	}
	break;
    case 'f':					/* next flame */
	change_flame(CHANGE_NEXT);
	break;
    case 'F':					/* prev flame */
	change_flame(CHANGE_PREV);
	break;
    case 'g': case 'G':
	change_flame_general();
	break;
    case 'w':					/* next wave-display */
	change_display_wave(CHANGE_NEXT);
	break;
    case 'W':					/* prev wave-display */
	change_display_wave(CHANGE_PREV);
	break;
    case 'd':					/* next display */
	change_update_screen(CHANGE_NEXT);
	break;
    case 'D':					/* prev display */
	change_update_screen(CHANGE_PREV);
	break;
    case 't':					/* next translation */
	change_translate(CHANGE_NEXT);
	break;
    case 'T':					/* prev translation */
	change_translate(CHANGE_PREV);
	break;
    case 'm':					/* next massage */
	change_massage_style(CHANGE_NEXT);
	break;
    case 'M':					/* prev massage */
	change_massage_style(CHANGE_PREV);
	break;
    case 's': case 'S':				/* toggle flashlight usage */
	change_flashlight(CHANGE_NEXT);
	break;
    case 'e': case 'E':
	change_FFT(CHANGE_NEXT);
	break;
    case 'p':					/* next palette */
	change_palette(CHANGE_NEXT,0);
	break;
    case 'P':					/* prev palette */
	change_palette(CHANGE_PREV,0);
	break;
    case 'b':					/* next table */
	change_table(CHANGE_NEXT);
	break;
    case 'B':					/* prev table */
	change_table(CHANGE_PREV);
	break;
    case 'l': case 'L':				/* lock */
	change_lock(CHANGE_NEXT);
	break;
    case 'i': case 'I':				/* information */
	status(1);
	break;
    case CK_FKT(1): case '1': case '': case '?':
	help();
	break;
    case '-':					/* Sample-Rate-1000 */
	if ( (sound_sample_rate -= 1000) <= 0)
	    sound_sample_rate = 0;
	sound_dsp_update();
	sprintf(str, "rate: %d %s", sound_sample_rate, 
		(sound_stereo-1) ? "STEREO" : "MONO");
	display_print(str, 0, 'r', 1);
	break;
    case '+':					/* Sample Rate+1000 */
	sound_sample_rate += 1000;
	sound_dsp_update();
	sprintf(str, "rate: %d %s", sound_sample_rate, 
		(sound_stereo-1) ? "STEREO" : "MONO");
	display_print(str, 0, 'r', 1);
	break;
    case '*':					/* toggle channels */
	sound_stereo = (sound_stereo == 1) ? 2 : 1;
	sound_dsp_update();
	sprintf(str, "rate: %d %s", sound_sample_rate, 
		(sound_stereo-1) ? "STEREO" : "MONO");
	display_print(str, 0, 'r', 1);
	break;
    case '<':
	sound_minnoise += 2;
    case '>':
	sound_minnoise --;
	if ( sound_minnoise < 0)	sound_minnoise = 0;
	if ( sound_minnoise > 256)	sound_minnoise = 256;
	sprintf(str, "Minnoise: %d", sound_minnoise);
	display_print(str, 0, 'r', 1);
	break;

    case 'x': case 'X':				/* show pcx-picture */
	if ( display_use_pcx) { 
	    int tmp = display_text_on_screen;
	    display_text_on_screen = 0;
	    show_pcx( 1 /*upper-left*/, 1 /*correct-colors*/);	

	    change_pcx( (key == 'x') ? CHANGE_NEXT : CHANGE_PREV);

	    display();
	    sleep(1);
	    display_text_on_screen = tmp;
	    update_palette();
	} else {
	    display_print("PCX is disabled", -1, 'r', 1);
	}
	break;
	
    case CK_FKT(2): case '2':
	select_screen();
	break;
    case CK_FKT(3): case '3':
	select_wave();
	break;
    case CK_FKT(4): case '4':
	select_flame();
	break;
    case CK_FKT(5): case '5':
	select_translate();
	break;
    case CK_FKT(6): case '6':
	select_palette();
	break;
    case CK_FKT(7): case '7':
	select_pcx(); 
	break;
	
    case 'a': case 'A':
	write_ini();
	break;
	
    case 'c': case 'C':
	interface_mode = IM_panel;
	break;

    case 'o': case 'O':
	interface_mode = IM_options;
	break;

    case 'n': case 'N':			/* send request to server */
	net_request(0);
	break;

    case CK_PRINT: case '#':		/* real print screen */
	save_display();
	break;

    default:				/* change everything */
	general_change();
	break;
    }
    update_status();
    return 1;
}


/*****************************************************************************
 * Selecton
 *****************************************************************************/

char * name_dest_str(char * name, char * desc) {
    static char str[MAX_NAME_LEN + MAX_DESC_LEN + 1];

    sprintf(str, "%-8s %25s", name, desc);
    str[34] = '\0';
    return str;
}

int selection(feature * what, char * title, int (* callback)(int)) {

    sel_what = what;
    sel_title = title;
    sel_line = what->current;
    sel_callback = callback;

    interface_mode = IM_selection;

    return 0;
}

#define SEL_SIZE	5
int do_selection() {
    char s[256];				/* temporary string */
    char text[20000];				/* text disp. on display */

    int i, key;

    /* create text for selection */
    strcpy(text, sel_title);
    for(i= sel_line - SEL_SIZE; i < sel_line + SEL_SIZE; i++) {
	if ( i < 0)
	    sprintf(s,"\n");
	else if ( i == sel_line)
	    sprintf(s, ">%34s%4s<\n", 
		    name_dest_str(sel_what->entries[i].name, 
				  sel_what->entries[i].desc),
		    sel_what->entries[i].use ? "ON" : "OFF");
	else if ( i < sel_what->nr_entries)
	    sprintf(s, " %34s%4s \n", 
		    name_dest_str(sel_what->entries[i].name, 
				  sel_what->entries[i].desc),
		    sel_what->entries[i].use ? "ON" : "OFF");
	else
	    strcpy(s, " \n");
	
	strcat( text, s);
    }
    
    display_print(text, 0, 'l', 0);
    
    while( (key = getkey() ) != CK_NONE  ) {
	switch( key ) {
	case CK_UP:
	    if (sel_line > 0)
		sel_line --;
	    break;
	case CK_DOWN:
	    if (sel_line < (sel_what->nr_entries-1))
		sel_line ++;
	    break;
	case CK_PGUP:
	    sel_line -= 2*SEL_SIZE-1;
	    if ( sel_line < 0)
		sel_line = 0;
	    break;
	case CK_PGDN:
	    sel_line += 2*SEL_SIZE+1;
	    if ( sel_line >= (sel_what->nr_entries-1))
		sel_line = sel_what->nr_entries -1;
	    break;
	case CK_HOME:
	    sel_line = 0;
	    break;
	case CK_END:
	    sel_line = sel_what->nr_entries -1;
	    break;
	case ' ':
	    sel_what->entries[sel_line].use = 
		1 - sel_what->entries[sel_line].use;
	    break;
	case CK_ENTER:
	    sel_what->entries[sel_line].use = 1;
	    display_print_clear();
	    interface_mode = IM_main;
	    return (*sel_callback)(sel_line);
	case CK_ESC: case 'q': case 'Q':
	    display_print_clear();
	    interface_mode = IM_main;
	    return -1;
	}
    }
    return -2;
}



